DesktopManager (Java Platform SE 8 )
Keywords: javax.swing.DesktopManager interface
Date: 2016-07-28

javax.swing

## Interface DesktopManager

- All Known Implementing Classes:
    DefaultDesktopManager

      public interface DesktopManager

  DesktopManager objects are owned by a JDesktopPane object. They are responsible for implementing L&F specific behaviors for the JDesktopPane. JInternalFrame implementations should delegate specific behaviors to the DesktopManager. For instance, if a JInternalFrame was asked to iconify, it should try:

          getDesktopPane().getDesktopManager().iconifyFrame(frame);

  This delegation allows each L&F to provide custom behaviors for desktop-specific actions. (For example, how and where the internal frame's icon would appear.)

  This class provides a policy for the various JInternalFrame methods, it is not meant to be called directly rather the various JInternalFrame methods will call into the DesktopManager.

  See Also:
    `JDesktopPane`, `JInternalFrame`, `JInternalFrame.JDesktopIcon`

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `activateFrame(JInternalFrame f)` Generally, indicate that this frame has focus.
    `void` | `beginDraggingFrame(JComponent f)` This method is normally called when the user has indicated that they will begin dragging a component around.
    `void` | `beginResizingFrame(JComponent f, int direction)` This methods is normally called when the user has indicated that they will begin resizing the frame.
    `void` | `closeFrame(JInternalFrame f)` Generally, this call should remove the frame from it's parent.
    `void` | `deactivateFrame(JInternalFrame f)` Generally, indicate that this frame has lost focus.
    `void` | `deiconifyFrame(JInternalFrame f)` Generally, remove any iconic representation that is present and restore the frame to it's original size and location.
    `void` | `dragFrame(JComponent f, int newX, int newY)` The user has moved the frame.
    `void` | `endDraggingFrame(JComponent f)` This method signals the end of the dragging session.
    `void` | `endResizingFrame(JComponent f)` This method signals the end of the resize session.
    `void` | `iconifyFrame(JInternalFrame f)` Generally, remove this frame from it's parent and add an iconic representation.
    `void` | `maximizeFrame(JInternalFrame f)` Generally, the frame should be resized to match it's parents bounds.
    `void` | `minimizeFrame(JInternalFrame f)` Generally, this indicates that the frame should be restored to it's size and position prior to a maximizeFrame() call.
    `void` | `openFrame(JInternalFrame f)` If possible, display this frame in an appropriate location.
    `void` | `resizeFrame(JComponent f, int newX, int newY, int newWidth, int newHeight)` The user has resized the component.
    `void` | `setBoundsForFrame(JComponent f, int newX, int newY, int newWidth, int newHeight)` This is a primitive reshape method.

- - ### Method Detail

    - #### openFrame

          void openFrame(JInternalFrame f)

      If possible, display this frame in an appropriate location. Normally, this is not called, as the creator of the JInternalFrame will add the frame to the appropriate parent.

    - #### closeFrame

          void closeFrame(JInternalFrame f)

      Generally, this call should remove the frame from it's parent.

    - #### maximizeFrame

          void maximizeFrame(JInternalFrame f)

      Generally, the frame should be resized to match it's parents bounds.

    - #### minimizeFrame

          void minimizeFrame(JInternalFrame f)

      Generally, this indicates that the frame should be restored to it's size and position prior to a maximizeFrame() call.

    - #### iconifyFrame

          void iconifyFrame(JInternalFrame f)

      Generally, remove this frame from it's parent and add an iconic representation.

    - #### deiconifyFrame

          void deiconifyFrame(JInternalFrame f)

      Generally, remove any iconic representation that is present and restore the frame to it's original size and location.

    - #### activateFrame

          void activateFrame(JInternalFrame f)

      Generally, indicate that this frame has focus. This is usually called after the JInternalFrame's IS_SELECTED_PROPERTY has been set to true.

    - #### deactivateFrame

          void deactivateFrame(JInternalFrame f)

      Generally, indicate that this frame has lost focus. This is usually called after the JInternalFrame's IS_SELECTED_PROPERTY has been set to false.

    - #### beginDraggingFrame

          void beginDraggingFrame(JComponent f)

      This method is normally called when the user has indicated that they will begin dragging a component around. This method should be called prior to any dragFrame() calls to allow the DesktopManager to prepare any necessary state. Normally f will be a JInternalFrame.

    - #### dragFrame

          void dragFrame(JComponent f,
                         int newX,
                         int newY)

      The user has moved the frame. Calls to this method will be preceded by calls to beginDraggingFrame(). Normally f will be a JInternalFrame.

    - #### endDraggingFrame

          void endDraggingFrame(JComponent f)

      This method signals the end of the dragging session. Any state maintained by the DesktopManager can be removed here. Normally f will be a JInternalFrame.

    - #### beginResizingFrame

          void beginResizingFrame(JComponent f,
                                  int direction)

      This methods is normally called when the user has indicated that they will begin resizing the frame. This method should be called prior to any resizeFrame() calls to allow the DesktopManager to prepare any necessary state. Normally f will be a JInternalFrame.

    - #### resizeFrame

          void resizeFrame(JComponent f,
                           int newX,
                           int newY,
                           int newWidth,
                           int newHeight)

      The user has resized the component. Calls to this method will be preceded by calls to beginResizingFrame(). Normally f will be a JInternalFrame.

    - #### endResizingFrame

          void endResizingFrame(JComponent f)

      This method signals the end of the resize session. Any state maintained by the DesktopManager can be removed here. Normally f will be a JInternalFrame.

    - #### setBoundsForFrame

          void setBoundsForFrame(JComponent f,
                                 int newX,
                                 int newY,
                                 int newWidth,
                                 int newHeight)

      This is a primitive reshape method.

Submit a bug or feature
For further API reference and developer documentation, see Java SE Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.
Copyright © 1993, 2016, Oracle and/or its affiliates. All rights reserved. Use is subject to license terms. Also see the documentation redistribution policy.